import * as React from 'react';
import { forwardRef, useMemo } from 'react';
import { escapeRegExp } from 'lodash';
import './index.scss';
function replace(content, keywords) {
  if (!(keywords !== null && keywords !== void 0 && keywords.length)) return content; // 'xxx'.replace('', 'xxx') 是有意义的

  var reg = new RegExp(keywords.map(function (_ref) {
    var word = _ref.word;
    return escapeRegExp(word);
  }).sort(function (a, b) {
    return b.length - a.length;
  }).join('|'), 'ig');
  return content.replace(reg, function (hit) {
    var exp = new RegExp(escapeRegExp(hit), 'ig');
    var _ref2 = keywords.find(function (_ref3) {
        var word = _ref3.word;
        return exp.test(word);
      }) || {},
      level = _ref2.level;
    return level ? "<span class=\"highlight " + level + "\">" + hit + "</span>" : hit;
  });
}
var Highlight = function Highlight(_ref4, ref) {
  var className = _ref4.className,
    _ref4$content = _ref4.content,
    content = _ref4$content === void 0 ? '测试文本测试文本测试文本测试文本测试文本' : _ref4$content,
    _ref4$keywords = _ref4.keywords,
    keywords = _ref4$keywords === void 0 ? [{
      word: '测试',
      level: 'high'
    }] : _ref4$keywords;
  var html = useMemo(function () {
    return replace(content, keywords);
  }, [content, keywords]);
  return /*#__PURE__*/React.createElement("div", {
    ref: ref,
    className: className,
    dangerouslySetInnerHTML: {
      __html: html
    }
  });
};
var RefExampleComponent = /*#__PURE__*/forwardRef(Highlight);
RefExampleComponent.displayName = 'Highlight';
export default RefExampleComponent;