"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var React = _interopRequireWildcard(require("react"));
var _lodash = require("lodash");
require("./index.scss");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function replace(content, keywords) {
  if (!(keywords !== null && keywords !== void 0 && keywords.length)) return content; // 'xxx'.replace('', 'xxx') 是有意义的

  var reg = new RegExp(keywords.map(function (_ref) {
    var word = _ref.word;
    return (0, _lodash.escapeRegExp)(word);
  }).sort(function (a, b) {
    return b.length - a.length;
  }).join('|'), 'ig');
  return content.replace(reg, function (hit) {
    var exp = new RegExp((0, _lodash.escapeRegExp)(hit), 'ig');
    var _ref2 = keywords.find(function (_ref3) {
        var word = _ref3.word;
        return exp.test(word);
      }) || {},
      level = _ref2.level;
    return level ? "<span class=\"highlight " + level + "\">" + hit + "</span>" : hit;
  });
}
var Highlight = function Highlight(_ref4, ref) {
  var className = _ref4.className,
    _ref4$content = _ref4.content,
    content = _ref4$content === void 0 ? '测试文本测试文本测试文本测试文本测试文本' : _ref4$content,
    _ref4$keywords = _ref4.keywords,
    keywords = _ref4$keywords === void 0 ? [{
      word: '测试',
      level: 'high'
    }] : _ref4$keywords;
  var html = (0, React.useMemo)(function () {
    return replace(content, keywords);
  }, [content, keywords]);
  return /*#__PURE__*/React.createElement("div", {
    ref: ref,
    className: className,
    dangerouslySetInnerHTML: {
      __html: html
    }
  });
};
var RefExampleComponent = /*#__PURE__*/(0, React.forwardRef)(Highlight);
RefExampleComponent.displayName = 'Highlight';
var _default = RefExampleComponent;
exports["default"] = _default;